module IndexFunArrays

using LinearAlgebra
using Base.Iterators

export IndexFunArray
export selectsizes, get_scale

const DEFAULT_T = Float64
const IterType = Union{NTuple{N,Tuple} where N, Vector, Matrix, Base.Iterators.Repeated}


include("scaling_offset_types.jl")
include("utils.jl")
include("other_ifas.jl")
# include docstrings
include("docstrings.jl")
include("scalar_ifas.jl")
include("window_ifas.jl")
include("tuple_ifas.jl")
include("ifa_type.jl")
# include("derivative_support.jl")


# These are the type promotion rules, taken from float.jl but written in terms of types
# see also 
promote_type()
default_type(::Type{Bool}, def_T)    = def_T
default_type(::Type{Int8}, def_T)    = def_T
default_type(::Type{Int16}, def_T)   = def_T
default_type(::Type{Int32}, def_T)   = def_T
default_type(::Type{Int64}, def_T)   = def_T # LOSSY
default_type(::Type{Int128}, def_T)  = def_T # LOSSY
default_type(::Type{UInt8}, def_T)   = def_T
default_type(::Type{UInt16}, def_T)  = def_T
default_type(::Type{UInt32}, def_T)  = def_T
default_type(::Type{UInt64}, def_T)  = def_T # LOSSY
default_type(::Type{UInt128}, def_T) = def_T # LOSSY
default_type(::Type{T}, def_T) where{T} = T # all other types remain to be the same



end # module
